<template>
  <div style="padding: 0px; margin: 0px">
    <q-dialog v-model="uploadAvatar" ref="dialogAvatar" persistent>
      <q-card style="min-width: 300px;">
        <q-card-section class="row items-center">
          <q-file
            accept="image/*"
            v-model="avatar"
            filled bottom-slots
            counter
          >
            <template v-slot:before>
              <q-icon name="account_circle" />
            </template>

            <template v-slot:hint>
              Pilih Gambar
            </template>
          </q-file>
        </q-card-section>

        <q-card-actions align="right">
          <q-btn flat label="Cancel" color="primary" v-close-popup />
          <q-btn label="Upload Avatar" color="primary" @click="doUploadAvatar" />
        </q-card-actions>
      </q-card>
    </q-dialog>

    <div class="q-pa-md" style="width: 80%; background: #4caf50; color: white; margin-top: 50px; margin-left: auto; margin-right: auto; box-shadow: 0 0px 8px 0 rgba(0,0,0,0.2), -7px 0 5px -3px #4caf50">
      <h6 style="margin: 0px">Profil Pengguna</h6>
    </div>
    <div class="q-pa-md" style="width: 80%; padding: 0; margin: auto; box-shadow: 0 0px 8px 0 rgba(0,0,0,0.2), -7px 0 5px -3px #4caf50">
      <div>
        <div style="text-align: center">
          <q-avatar size="200px" style="margin-top: 30px">
            <img :src="avatarUser || 'https://cdn.quasar.dev/img/avatar.png'">
          </q-avatar>
        </div>
        <div style="text-align: center">
          <q-btn size="20px" color="green" @click="uploadAvatar = true" icon="cloud_upload" label="Pilih Gambar" style="margin-top: 20px"/>
        </div>
        <div>
          <div style="width: 100%; padding: 0; margin-top: 50px"  class="q-pa-md">
            <div class="q-gutter-y-md" style="width: 100%">
              <q-card>
                <q-tabs
                  v-model="tab"
                  dense
                  class="text-grey"
                  active-color="green"
                  indicator-color="green"
                  align="justify"
                  narrow-indicator
                >
                  <q-tab name="biodata" label="Biodata Pribadi" />
                  <q-tab name="alamat" label="Alamat" />

                </q-tabs>

                <q-separator />

                <q-tab-panels v-model="tab" animated >
                  <q-tab-panel name="biodata">
                    <q-form
                      @submit="submitProfile"
                      @reset="onReset"
                      class="q-gutter-md"
                    >
                      <q-input
                        standout="bg-green text-white"
                        label="Email"
                        v-model="user.email"
                        readonly
                      />
                      <q-input v-if="profile" standout="bg-green text-white" v-model="profile.ktp" label="NIK"/>
                      <q-input v-if="profile" standout="bg-green text-white" v-model="profile.npwp" label="Nomor NPWP"/>
                      <q-select v-if="profile" standout="bg-green text-white" v-model="profile.jenis_kelamin" :options="optionsJk" label="Pilih Jenis Kelamin" />
                      <q-input v-if="profile" standout="bg-green text-white" v-model="jenis_penguna" readonly label="Level Berlangganan"/>
                      <q-input v-if="profile" standout="bg-green text-white" v-model="profile.no_hp" label="Nomor Handphone"/>
                      <q-input v-if="profile" standout="bg-green text-white" v-model="profile.tempat_lahir" label="Tempat Lahir"/>
                      <q-input v-if="profile" standout="bg-green text-white" filled v-model="profile.tgl_lahir" type="date" hint="Tanggal Lahir">
                        <template v-slot:prepend>
                          <q-icon name="event" />
                        </template>
                      </q-input>
                      <div style="text-align: center">
                        <q-btn size="19px" label="Simpan Profile" @click="submitProfile" color="green"/>
                      </div>
                    </q-form>
                  </q-tab-panel>

                  <q-tab-panel name="alamat">
                    <q-form

                      @submit="submitAddress"
                      @reset="onReset"
                      class="q-gutter-md"
                    >
                      <q-input standout="bg-green text-white" v-model="address.alamat" label="Alamat" type="textarea"/>
                      <q-select standout="bg-green text-white" ref="pilihKota" @input="getKota" v-model="provinsi" :options="optionsProvinsi" label="Pilih Provinsi" />
                      <q-select standout="bg-green text-white" @input="getKecamatan"  v-model="kota" :options="optionsKota" label="Pilih Kabupaten/Kota" />
                      <q-select standout="bg-green text-white" @input="getDesa" v-model="kecamatan" :options="optionsKecamatan" label="Pilih Kecamatan" />
                      <q-select standout="bg-green text-white" v-model="desa" :options="optionsDesa" label="Pilih Kelurahan" />
                      <div class="row">
                        <q-input style="padding-right: 5px" class="col-6" standout="bg-green text-white" v-model="address.rt" label="RT" />
                        <q-input style="padding-left: 5px" class="col-6" standout="bg-green text-white" v-model="address.rw" label="RW" />
                      </div>
                      <q-input standout="bg-green text-white" v-model="address.kode_pos" label="Kode Pos" />
                      <div style="text-align: center">
                        <q-btn size="19px" label="Simpan Alamat" @click="submitAddress" color="green"/>
                      </div>
                    </q-form>
                  </q-tab-panel>
                </q-tab-panels>
                <p>&nbsp;</p>
              </q-card>
            </div>
          </div>
        </div>
      </div>
    </div>
    <p>&nbsp;</p>
  </div>
</template>

<script>

export default {
  name: "ProfileMobile",

  computed: {
    avatarUser: {
      get () {
        return this.$store.getters["user/getAvatar"]
      },
      set (val) {

      }
    }
  },

  beforeMount() {
    this.getUserProfile();
  },

  mounted() {
    this.getProvinsi();
  },

  data () {
    return {
      uploadAvatar: false,
      avatar: null,
      tab: 'biodata',
      name: null,
      age: null,
      token: "Bearer " + localStorage.getItem("token"),
      accept: false,
      jenis_penguna: "Silver",
      optionsJk: ["Laki-laki", "Perempuan"],
      optionsProvinsi: [],
      provinsi:[],

      optionsKota: [],
      kota:[],

      optionsKecamatan: [],
      kecamatan:[],

      optionsDesa: [],
      desa:[],

      user: {},
      profile: {},
      address: {}
    }
  },

  methods: {
    doUploadAvatar: function () {
        let avatarOke = true
        let formData = new FormData();

        if (!this.avatar) {
          avatarOke = false
        }

        if (!avatarOke) {
          this.$q.notify({
            color: 'red-5',
            textColor: 'white',
            icon: 'warning',
            message: 'Avatar Tidak Boleh Kosong'
          })
        } else {
          formData.append("avatar", this.avatar)

          let dataUpload = {
            method: "POST",
            data: formData,
            url: "api/add-avatar",
            headers: {
              Authorization: this.token
            }
          }

          this.$q.loading.show()

          this.$axios(dataUpload)

          .then(sukses => {
            this.$refs.dialogAvatar.hide();
            this.$q.loading.hide()

            this.$store.commit("user/updateUserDetail", sukses.data)

            this.$q.notify({
              color: 'green-5',
              textColor: 'white',
              icon: 'warning',
              message: 'Berhasil Upload Avatar'
            })
          })

          .catch(gagal => {
            this.$q.loading.hide()

            this.$q.notify({
              color: 'red-5',
              textColor: 'white',
              icon: 'warning',
              message: 'Koneksi Gagal'
            })
          })
        }


    },

    getUserProfile: function () {
      this.$q.loading.show()
      let apiUrl = {
        url : "api/details",
        method: "post",
        headers: {
          Authorization: this.token
        }
      }

      this.$axios(apiUrl)
        .then(sukses => {
          this.$q.loading.hide();
          this.user = sukses.data.data;
          this.profile = sukses.data.data.profile;
          this.address = sukses.data.data.address;

          if (this.address.provinsi) {
            this.provinsi = {
              label : this.address.provinsi.name,
              value : this.address.provinsi.id
            }
            this.getKota()
          }

          if (this.address.kota) {
            this.kota = {
              label : this.address.kota.name,
              value : this.address.kota.id
            }
            this.getKecamatan()
          }

          if (this.address.kecamatan) {
            this.kecamatan = {
              label : this.address.kecamatan.name,
              value : this.address.kecamatan.id
            }
            this.getDesa()
          }

          if (this.address.desa) {
            this.desa = {
              label : this.address.desa.name,
              value : this.address.desa.id
            }
          }


        })

        .catch(error => {
          this.$q.loading.hide()
        })
    },

    getDesa: function () {
      this.desa = null

      this.$q.loading.show()
      let apiUrl = {
        url : "api/wilayah/desa/" + this.kecamatan.value,
        headers: {
          Authorization: this.token
        }
      }

      this.$axios(apiUrl)
        .then(sukses => {
          this.$q.loading.hide();

          let data = sukses.data.villages
          this.optionsDesa = []

          for (let i = 0; i < data.length; i++) {
            let dataX = {
              label: data[i].name,
              value: data[i].id
            }
            this.optionsDesa.push(dataX)
          }

        })
    },

    getKecamatan: function () {
      this.kecamatan = null
      this.desa = null

      this.$q.loading.show()
      let apiUrl = {
        url : "api/wilayah/kecamatan/" + this.kota.value,
        headers: {
          Authorization: this.token
        }
      }

      this.$axios(apiUrl)
        .then(sukses => {
          this.$q.loading.hide();

          let data = sukses.data.districts
          this.optionsKecamatan = []

          for (let i = 0; i < data.length; i++) {
            let dataX = {
              label: data[i].name,
              value: data[i].id
            }
            this.optionsKecamatan.push(dataX)
          }

        })
    },

    getKota: function () {
      this.kota = null
      this.kecamatan = null
      this.desa = null

      this.$q.loading.show()
      let apiUrl = {
        url : "api/wilayah/kota/" + this.provinsi.value,
        headers: {
          Authorization: this.token
        }
      }

      this.$axios(apiUrl)
        .then(sukses => {
          this.$q.loading.hide();

          let data = sukses.data.cities
          this.optionsKota = []

          for (let i = 0; i < data.length; i++) {
            let dataX = {
              label: data[i].name,
              value: data[i].id
            }
            this.optionsKota.push(dataX)
          }

        })
    },

    getProvinsi() {
      this.$q.loading.show()
      let apiUrl = {
        url : "api/wilayah/provinsi",
        headers: {
          Authorization: this.token
        }
      }

      this.$axios(apiUrl)
      .then(sukses => {
        this.$q.loading.hide();

        let data = sukses.data

        for (let i = 0; i < data.length; i++) {
          let dataX = {
            label: data[i].name,
            value: data[i].id
          }
          this.optionsProvinsi.push(dataX)
        }

      })
    },

    async submitAddress () {
      let alamatOke = true;

      let formData = new FormData();

      await formData.append("provinsi_id", this.provinsi.value)
      if (!this.provinsi.value) {
        alamatOke = false
      }

      await formData.append("kota_id", this.kota.value)
      if (!this.kota.value) {
        alamatOke = false
      }

      await formData.append("kecamatan_id", this.kecamatan.value)
      if (!this.kecamatan.value) {
        alamatOke = false
      }

      await formData.append("desa_id", this.desa.value)
      if (!this.desa.value) {
        alamatOke = false
      }

      await formData.append("rt", this.address.rt)
      await formData.append("rw", this.address.rw)
      await formData.append("kode_pos", this.address.kode_pos)
      await formData.append("alamat", this.address.alamat)
      if (!this.address.rt || !this.address.rw || !this.address.kode_pos || !this.address.alamat) {
        alamatOke = false
      }

      if (alamatOke === false) {
        this.$q.notify({
          color: 'red-5',
          textColor: 'white',
          icon: 'warning',
          message: 'Mohon Lengkapi Data Alamat'
        })
      }
      else {
        let configProfile = {
          method: "POST",
          url: "api/users/address/update",
          data: formData,
          headers: {
            Authorization: this.token
          }
        }
        this.$q.loading.show()
        this.$axios(configProfile)
          .then(sukses => {
            this.$q.loading.hide()
            this.$store.commit("user/updateUserDetail", sukses.data)
            this.$q.notify({
              color: 'green-4',
              textColor: 'white',
              icon: 'cloud_done',
              message: 'Berhasil Simpan Alamat'
            })
          })

          .catch(gagal => {
            this.$q.loading.hide()
            this.$q.notify({
              color: 'red-4',
              textColor: 'white',
              icon: 'cloud_done',
              message: 'Gagal Koneksi'
            })
          })
      }
    },

    async submitProfile () {
      let profileOke = true;

      let formData = new FormData();

      await formData.append("ktp", this.profile.ktp)
      await formData.append("npwp", this.profile.npwp)
      await formData.append("no_hp", this.profile.no_hp)
      await formData.append("jenis_kelamin", this.profile.jenis_kelamin)
      await formData.append("tempat_lahir", this.profile.tempat_lahir)
      await formData.append("tgl_lahir", this.profile.tgl_lahir)

      if (!this.profile.ktp || !this.profile.npwp || !this.profile.no_hp || !this.profile.jenis_kelamin || !this.profile.tempat_lahir || !this.profile.tgl_lahir) {
        profileOke = false
      }

      if (profileOke === false) {
        this.$q.notify({
          color: 'red-5',
          textColor: 'white',
          icon: 'warning',
          message: 'Mohon Lengkapi Data Profile'
        })
      }
      else {
        let configProfile = {
          method: "POST",
          url: "api/users/profile/update",
          data: formData,
          headers: {
            Authorization: this.token
          }
        }
        this.$q.loading.show()
        this.$axios(configProfile)
        .then(sukses => {
          this.$q.loading.hide()
          this.$store.commit("user/updateUserDetail", sukses.data)
          this.$q.notify({
            color: 'green-4',
            textColor: 'white',
            icon: 'cloud_done',
            message: 'Berhasil Simpan Profile'
          })
        })

        .catch(gagal => {
          this.$q.loading.hide()
          this.$q.notify({
            color: 'red-4',
            textColor: 'white',
            icon: 'cloud_done',
            message: 'Gagal Koneksi'
          })
        })


      }
    },

    onReset () {
      this.name = null
      this.age = null
      this.accept = false
    }
  }
}

</script>

<style scoped>

</style>
